diff a/src/hotspot/share/gc/shared/weakProcessorPhases.hpp b/src/hotspot/share/gc/shared/weakProcessorPhases.hpp
--- a/src/hotspot/share/gc/shared/weakProcessorPhases.hpp
+++ b/src/hotspot/share/gc/shared/weakProcessorPhases.hpp
@@ -41,17 +41,18 @@
   typedef void (*Processor)(BoolObjectClosure*, OopClosure*);
 
   enum Phase {
     // Serial phases.
     JVMTI_ONLY(jvmti JFR_ONLY(COMMA))
-    JFR_ONLY(jfr)
+    JFR_ONLY(jfr TSAN_ONLY(COMMA))
+    TSAN_ONLY(tsan)
 
     // Additional implicit phase values follow for oopstorages.
   };
 
   static const uint serial_phase_start = 0;
-  static const uint serial_phase_count = 0 JVMTI_ONLY(+ 1) JFR_ONLY(+ 1);
+  static const uint serial_phase_count = 0 JVMTI_ONLY(+ 1) JFR_ONLY(+ 1) TSAN_ONLY(+ 1);
   static const uint oopstorage_phase_start = serial_phase_count;
   static const uint oopstorage_phase_count = OopStorageSet::weak_count;
   static const uint phase_count = serial_phase_count + oopstorage_phase_count;
 
   // Precondition: value < serial_phase_count
